libstdc++: __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category > Class Template Reference

libstdc++

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category > Class Template Reference

`#include <safe_iterator.h>`

Inheritance diagram for __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >:
[legend]

## Public Types
typedef _Safe_iterator< _Iterator, _Sequence, iterator_category > | _Self
typedef _Traits::difference_type | difference_type
typedef _Traits::iterator_category | iterator_category
using | iterator_concept
typedef _Iterator | iterator_type
typedef _Traits::pointer | pointer
typedef _Traits::reference | reference
typedef _Traits::value_type | value_type

## Public Member Functions
constexpr | _Safe_iterator () noexcept
constexpr | _Safe_iterator (_Iterator __i, const _Safe_sequence_base *__seq) noexcept
constexpr | _Safe_iterator (_Safe_iterator &&__x) noexcept
constexpr | _Safe_iterator (const _Safe_iterator &__x) noexcept
template<typename _MutableIterator>
constexpr | _Safe_iterator (const _Safe_iterator< _MutableIterator, _Sequence, typename __gnu_cxx::__enable_if< _IsConstant::__value &&std::__are_same< _MutableIterator, _OtherIterator >::__value, _Category >::__type > &__x) noexcept
void | _M_attach (const _Safe_sequence_base *__seq)
void | _M_attach_single (const _Safe_sequence_base *__seq)
bool | _M_attached_to (const _Safe_sequence_base *__seq) const
bool | _M_before_dereferenceable () const
template<typename _Diff>
bool | _M_can_advance (const std::pair< _Diff, _Distance_precision > &__dist, int __way) const
bool | _M_can_advance (difference_type __n, bool __strict=false) const
bool | _M_can_compare (const _Safe_iterator_base &__x) const noexcept
bool | _M_dereferenceable () const
void | _M_detach_single () noexcept
_Distance_traits< _Iterator >::__type | _M_get_distance_from_begin () const
_Distance_traits< _Iterator >::__type | _M_get_distance_to (const _Safe_iterator &__rhs) const
_Distance_traits< _Iterator >::__type | _M_get_distance_to_end () const
__gnu_cxx::__conditional_type< _IsConstant::__value, const_Sequence *, _Sequence * >::__type | _M_get_sequence () const
bool | _M_incrementable () const
void | _M_invalidate ()
bool | _M_is_before_begin () const
constexpr bool | _M_is_begin () const
bool | _M_is_beginnest () const
bool | _M_is_end () const
void | _M_reset () noexcept
bool | _M_singular () const noexcept
void | _M_unlink () noexcept
bool | _M_valid_range (const _Safe_iterator &__rhs, std::pair< difference_type, _Distance_precision > &__dist, bool __check_dereferenceable=true) const
bool | _M_value_initialized () const
constexpr const _Iterator & | base () const noexcept
constexpr _Iterator & | base () noexcept
constexpr | operator _Iterator () const noexcept
constexpr reference | operator* () const noexcept
constexpr _Safe_iterator & | operator++ () noexcept
constexpr _Safe_iterator | operator++ (int) noexcept
constexpr pointer | operator-> () const noexcept
constexpr _Safe_iterator & | operator= (_Safe_iterator &&__x) noexcept
constexpr _Safe_iterator & | operator= (const _Safe_iterator &__x) noexcept

## Static Public Member Functions
static constexpr bool | _S_constant ()
template<typename _Fn>
static constexpr _Self | _S_for_each_segment (_Self __first, _Self __last, _Fn __func)

## Public Attributes
_Safe_iterator_base * | _M_next
_Safe_iterator_base * | _M_prior
const _Safe_sequence_base * | _M_sequence
unsigned int | _M_version

## Static Public Attributes
static const bool | _S_enable_for_each_segment

## Protected Types
typedef std::__are_same< typename _Sequence::_Base::const_iterator, _Iterator > | _IsConstant
typedef __gnu_cxx::__conditional_type< _IsConstant::__value, typename_Sequence::_Base::iterator, typename_Sequence::_Base::const_iterator >::__type | _OtherIterator

## Protected Member Functions
constexpr | _Safe_iterator (const _Safe_iterator &__x, _Unchecked) noexcept
void | _M_attach (const _Safe_sequence_base *__seq, bool __constant)
void | _M_attach_single (const _Safe_sequence_base *__seq, bool __constant) noexcept
void | _M_detach ()
__gnu_cxx::__mutex & | _M_get_mutex () noexcept

## Friends
template<typename _IteR>
constexpr friend bool | operator== (const _Self &__lhs, const _Safe_iterator< _IteR, _Sequence, iterator_category > &__rhs) noexcept
constexpr friend bool | operator== (const _Self &__lhs, const _Self &__rhs) noexcept

## Detailed Description

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>
class __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >

Safe iterator wrapper.

The class template _Safe_iterator is a wrapper around an iterator that tracks the iterator's movement among sequences and checks that operations performed on the "safe" iterator are legal. In additional to the basic iterator operations (which are validated, and then passed to the underlying iterator), _Safe_iterator has member functions for iterator invalidation, attaching/detaching the iterator from sequences, and querying the iterator's state.

Note that _Iterator must be the first base class so that it gets initialized before the iterator is being attached to the container's list of iterators and it is being detached before _Iterator get destroyed. Otherwise it would result in a data race.

Definition at line 130 of file safe_iterator.h.

## Member Typedef Documentation

## ◆ _IsConstant

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef std::__are_same<typename _Sequence::_Base::const_iterator, _Iterator> __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_IsConstant
| protected

Definition at line 138 of file safe_iterator.h.

## ◆ _OtherIterator

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef __gnu_cxx::__conditional_type<_IsConstant::__value,typename_Sequence::_Base::iterator,typename_Sequence::_Base::const_iterator>::__type __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_OtherIterator
| protected

Definition at line 143 of file safe_iterator.h.

## ◆ _Self

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef _Safe_iterator<_Iterator, _Sequence, iterator_category> __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_Self

Definition at line 542 of file safe_iterator.h.

## ◆ difference_type

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef _Traits::difference_type __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::difference_type

Definition at line 156 of file safe_iterator.h.

## ◆ iterator_category

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef _Traits::iterator_category __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::iterator_category

Definition at line 154 of file safe_iterator.h.

## ◆ iterator_concept

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

using __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::iterator_concept

Definition at line 161 of file safe_iterator.h.

## ◆ iterator_type

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef _Iterator __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::iterator_type

Definition at line 153 of file safe_iterator.h.

## ◆ pointer

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef _Traits::pointer __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::pointer

Definition at line 158 of file safe_iterator.h.

## ◆ reference

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef _Traits::reference __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::reference

Definition at line 157 of file safe_iterator.h.

## ◆ value_type

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

typedef _Traits::value_type __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::value_type

Definition at line 155 of file safe_iterator.h.

## Constructor & Destructor Documentation

## ◆ _Safe_iterator() [1/6]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_Safe_iterator | ( | const _Safe_iterator< _Iterator, _Sequence, _Category > & | __x,
|  | _Unchecked | )
| inlineconstexprprotectednoexcept

Definition at line 148 of file safe_iterator.h.

## ◆ _Safe_iterator() [2/6]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_Safe_iterator | ( |  | ) |
| inlineconstexprnoexcept

Postcondition
  the iterator is singular and unattached

Definition at line 166 of file safe_iterator.h.

## ◆ _Safe_iterator() [3/6]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_Safe_iterator | ( | _Iterator | __i,
|  | const _Safe_sequence_base * | __seq )
| inlineconstexprnoexcept

Safe iterator construction from an unsafe iterator and its sequence.

Precondition
  `seq` is not NULL

Postcondition
  this is not singular

Definition at line 176 of file safe_iterator.h.

## ◆ _Safe_iterator() [4/6]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_Safe_iterator | ( | const _Safe_iterator< _Iterator, _Sequence, _Category > & | __x | ) |
| inlineconstexprnoexcept

Copy construction.

Definition at line 185 of file safe_iterator.h.

## ◆ _Safe_iterator() [5/6]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_Safe_iterator | ( | _Safe_iterator< _Iterator, _Sequence, _Category > && | __x | ) |
| inlineconstexprnoexcept

Move construction.

Postcondition
  __x is singular and unattached

Definition at line 207 of file safe_iterator.h.

## ◆ _Safe_iterator() [6/6]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>
template<typename _MutableIterator>

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_Safe_iterator | ( | const _Safe_iterator< _MutableIterator, _Sequence, typename __gnu_cxx::__enable_if< _IsConstant::__value &&std::__are_same< _MutableIterator, _OtherIterator >::__value, _Category >::__type > & | __x | ) |
| inlineconstexprnoexcept

Converting constructor from a mutable iterator to a constant iterator.

Definition at line 234 of file safe_iterator.h.

## Member Function Documentation

## ◆ _M_attach() [1/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

void __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_attach | ( | const _Safe_sequence_base * | __seq | ) |
| inline

Attach iterator to the given sequence.

Definition at line 442 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=().

## ◆ _M_attach() [2/2]

void __gnu_debug::_Safe_iterator_base::_M_attach | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )
| protectedinherited

Attaches this iterator to the given sequence, detaching it from whatever sequence it was attached to originally. If the new sequence is the NULL pointer, the iterator is left unattached.

References _M_attach().

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach(), and _M_attach().

## ◆ _M_attach_single() [1/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

void __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_attach_single | ( | const _Safe_sequence_base * | __seq | ) |
| inline

Likewise, but not thread-safe.

Definition at line 447 of file safe_iterator.h.

## ◆ _M_attach_single() [2/2]

void __gnu_debug::_Safe_iterator_base::_M_attach_single | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )
| protectednoexceptinherited

Likewise, but not thread-safe.

References _M_attach_single().

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach_single(), and _M_attach_single().

## ◆ _M_attached_to()

bool __gnu_debug::_Safe_iterator_base::_M_attached_to | ( | const _Safe_sequence_base * | __seq | ) | const
| inlineinherited

Determines if we are attached to the given sequence.

Definition at line 161 of file safe_base.h.

References _M_attached_to(), and _M_sequence.

Referenced by _M_attached_to().

## ◆ _M_before_dereferenceable()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_before_dereferenceable | ( |  | ) | const
| inline

Is the iterator before a dereferenceable one?

Definition at line 457 of file safe_iterator.h.

## ◆ _M_can_advance() [1/2]

template<typename _Iterator, typename _Sequence, typename _Category>
template<typename _Diff>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_can_advance | ( | const std::pair< _Diff, _Distance_precision > & | __dist,
|  | int | __way ) const

Definition at line 113 of file safe_iterator.tcc.

## ◆ _M_can_advance() [2/2]

template<typename _Iterator, typename _Sequence, typename _Category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_can_advance | ( | difference_type | __n,
|  | bool | __strict = false ) const

Definition at line 86 of file safe_iterator.tcc.

## ◆ _M_can_compare()

bool __gnu_debug::_Safe_iterator_base::_M_can_compare | ( | const _Safe_iterator_base & | __x | ) | const
| noexceptinherited

Can we compare this iterator to the given iterator `__x`? Returns true if both iterators are nonsingular and reference the same sequence.

References _Safe_iterator_base(), and _M_can_compare().

Referenced by _M_can_compare().

## ◆ _M_dereferenceable()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_dereferenceable | ( |  | ) | const
| inline

Is the iterator dereferenceable?

Definition at line 452 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator*(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator->().

## ◆ _M_detach()

void __gnu_debug::_Safe_iterator_base::_M_detach | ( |  | ) |
| protectedinherited

Detach the iterator for whatever sequence it is attached to, if any.

References _M_detach().

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), _M_detach(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=().

## ◆ _M_detach_single()

void __gnu_debug::_Safe_iterator_base::_M_detach_single | ( |  | ) |
| noexceptinherited

Likewise, but not thread-safe.

## ◆ _M_get_distance_from_begin()

template<typename _Iterator, typename _Sequence, typename _Category>

_Distance_traits< _Iterator >::__type __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_get_distance_from_begin | ( |  | ) | const

Definition at line 38 of file safe_iterator.tcc.

## ◆ _M_get_distance_to()

template<typename _Iterator, typename _Sequence, typename _Category>

_Distance_traits< _Iterator >::__type __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_get_distance_to | ( | const _Safe_iterator< _Iterator, _Sequence, _Category > & | __rhs | ) | const

Definition at line 126 of file safe_iterator.tcc.

## ◆ _M_get_distance_to_end()

template<typename _Iterator, typename _Sequence, typename _Category>

_Distance_traits< _Iterator >::__type __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_get_distance_to_end | ( |  | ) | const

Definition at line 62 of file safe_iterator.tcc.

## ◆ _M_get_mutex()

__gnu_cxx::__mutex & __gnu_debug::_Safe_iterator_base::_M_get_mutex | ( |  | ) |
| protectednoexceptinherited

For use in _Safe_iterator.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator++(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator++(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_get_sequence()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

__gnu_cxx::__conditional_type< _IsConstant::__value, const_Sequence *, _Sequence * >::__type __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_get_sequence | ( |  | ) | const
| inline

Definition at line 496 of file safe_iterator.h.

## ◆ _M_incrementable()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_incrementable | ( |  | ) | const
| inline

Is the iterator incrementable?

Definition at line 469 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_before_dereferenceable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator++(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator++().

## ◆ _M_invalidate()

void __gnu_debug::_Safe_iterator_base::_M_invalidate | ( |  | ) |
| inlineinherited

Invalidate the iterator, making it singular.

Definition at line 176 of file safe_base.h.

References _M_invalidate(), and _M_version.

Referenced by _M_invalidate().

## ◆ _M_is_before_begin()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_is_before_begin | ( |  | ) | const
| inline

Is this iterator equal to the sequence's before_begin() iterator if any?

Definition at line 531 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_dereferenceable().

## ◆ _M_is_begin()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_is_begin | ( |  | ) | const
| inlineconstexpr

Is this iterator equal to the sequence's begin() iterator?

Definition at line 520 of file safe_iterator.h.

## ◆ _M_is_beginnest()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_is_beginnest | ( |  | ) | const
| inline

Is this iterator equal to the sequence's before_begin() iterator if any or begin() otherwise?

Definition at line 537 of file safe_iterator.h.

## ◆ _M_is_end()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_is_end | ( |  | ) | const
| inline

Is this iterator equal to the sequence's end() iterator?

Definition at line 525 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_dereferenceable(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_incrementable().

## ◆ _M_reset()

void __gnu_debug::_Safe_iterator_base::_M_reset | ( |  | ) |
| noexceptinherited

Reset all member variables

## ◆ _M_singular()

bool __gnu_debug::_Safe_iterator_base::_M_singular | ( |  | ) | const
| noexceptinherited

Is this iterator singular?

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::__check_singular_aux(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_dereferenceable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_dereferenceable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_incrementable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_incrementable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_unlink()

void __gnu_debug::_Safe_iterator_base::_M_unlink | ( |  | ) |
| inlinenoexceptinherited

Unlink itself

Definition at line 185 of file safe_base.h.

References _M_next, _M_prior, and _M_unlink().

Referenced by _M_unlink().

## ◆ _M_valid_range()

template<typename _Iterator, typename _Sequence, typename _Category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_valid_range | ( | const _Safe_iterator< _Iterator, _Sequence, _Category > & | __rhs,
|  | std::pair< difference_type, _Distance_precision > & | __dist,
|  | bool | __check_dereferenceable = true ) const

Definition at line 195 of file safe_iterator.tcc.

## ◆ _M_value_initialized()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_value_initialized | ( |  | ) | const
| inline

Is the iterator value-initialized?

Definition at line 474 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=().

## ◆ _S_constant()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

constexpr bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_S_constant | ( |  | ) |
| inlinestaticconstexpr

Determine if this is a constant iterator.

Definition at line 419 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach_single().

## ◆ _S_for_each_segment()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>
template<typename _Fn>

constexpr _Self __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_S_for_each_segment | ( | _Self | __first,
|  | _Self | __last,
|  | _Fn | __func )
| inlinestaticconstexpr

Definition at line 588 of file safe_iterator.h.

## ◆ base() [1/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

const _Iterator & __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::base | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 431 of file safe_iterator.h.

## ◆ base() [2/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

_Iterator & __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::base | ( |  | ) |
| inlineconstexprnoexcept

Return the underlying iterator.

Definition at line 427 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_before_dereferenceable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_is_begin(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_is_end(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_value_initialized(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator*(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator++(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator->(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=().

## ◆ operator _Iterator()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

__gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator _Iterator | ( |  | ) | const
| inlineconstexprnoexcept

Conversion to underlying non-debug iterator to allow better interaction with non-debug containers.

Definition at line 438 of file safe_iterator.h.

## ◆ operator*()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

reference __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator* | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Iterator dereference.

Precondition
  iterator is dereferenceable

Definition at line 342 of file safe_iterator.h.

## ◆ operator++() [1/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

_Safe_iterator & __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator++ | ( |  | ) |
| inlineconstexprnoexcept

Iterator preincrement.

Precondition
  iterator is incrementable

Definition at line 378 of file safe_iterator.h.

## ◆ operator++() [2/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

_Safe_iterator __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator++ | ( | int |  | ) |
| inlineconstexprnoexcept

Iterator postincrement.

Precondition
  iterator is incrementable

Definition at line 402 of file safe_iterator.h.

## ◆ operator->()

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

pointer __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator-> | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Iterator dereference.

Precondition
  iterator is dereferenceable

Definition at line 360 of file safe_iterator.h.

## ◆ operator=() [1/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

_Safe_iterator & __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator= | ( | _Safe_iterator< _Iterator, _Sequence, _Category > && | __x | ) |
| inlineconstexprnoexcept

Move assignment.

Postcondition
  __x is singular and unattached

Definition at line 299 of file safe_iterator.h.

## ◆ operator=() [2/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

_Safe_iterator & __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator= | ( | const _Safe_iterator< _Iterator, _Sequence, _Category > & | __x | ) |
| inlineconstexprnoexcept

Copy assignment.

Definition at line 260 of file safe_iterator.h.

## Friends And Related Symbol Documentation

## ◆ operator== [1/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>
template<typename _IteR>

friend bool operator== | ( | const _Self & | __lhs,
|  | const _Safe_iterator< _IteR, _Sequence, iterator_category > & | __rhs )
| friend

Definition at line 557 of file safe_iterator.h.

## ◆ operator== [2/2]

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

friend bool operator== | ( | const _Self & | __lhs,
|  | const _Self & | __rhs )
| friend

Definition at line 547 of file safe_iterator.h.

## Member Data Documentation

## ◆ _M_next

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_next
| inherited

Pointer to the next iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 76 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## ◆ _M_prior

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_prior
| inherited

Pointer to the previous iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 72 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## ◆ _M_sequence

const _Safe_sequence_base* __gnu_debug::_Safe_iterator_base::_M_sequence
| inherited

The sequence this iterator references; may be NULL to indicate a singular iterator. Stored as pointer-to-const because sequence could be declared as const.

Definition at line 59 of file safe_base.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_attached_to(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_version

unsigned int __gnu_debug::_Safe_iterator_base::_M_version
| inherited

The version number of this iterator. The sentinel value 0 is used to indicate an invalidated iterator (i.e., one that is singular because of an operation on the container). This version number must equal the version number in the sequence referenced by _M_sequence for the iterator to be non-singular.

Definition at line 68 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_invalidate(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## ◆ _S_enable_for_each_segment

template<typename _Iterator, typename _Sequence, typename _Category = typename std::iterator_traits<_Iterator>::iterator_category>

const bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_S_enable_for_each_segment
| static

Definition at line 596 of file safe_iterator.h.

The documentation for this class was generated from the following files:

- boost_concept_check.h
- safe_iterator.h
- safe_iterator.tcc